#
# M    graph  link
# (   router)
#
#
#
# $LIB_PL=".";
require "$LIB_PL/build_graph.pll";
# use strict;
1;
#
#   - 2 
# 1. 1  /       - for 
# 2. 1  /    - for 1 hour
#
# ,     .
#  1 -  yes.
#  - file, title, mode.
# mode = 0 - report, 1 - graph, 2 - zoomed graph
sub plot_mser {
my($dir, $title, $mode, $date) = (@_);
my(@L_failed) = ();       # L failed
my(@L_total) = ();        # L total
my(@L_user)  = ();        # USERS
my(@L_max) = ();          # USERD, max
my(@L_idle) = ();         # IDLE
my(@L_on, @L_off);        # ON  OFF, 1 -  MAX
my(@L_NN);                #     , for 
my(@CO_ok) = ();          # Call OK/
my(@CO_failed) = ();      # Call /
my(@CO_NN);               #  ,    for 
my($L_MAX, $CO_MAX) = (1,1);
#
#  
my $S_Gx = 100;
my $S_Gy = 100;
my $Max_i;
#
if ( $mode != 2 ) {
    $S_Gx = 100;
    $S_Gy = 240;
};
if ( $mode == 2 ) {
    $S_Gx = 200;
    $S_Gy = 480;
};
#
my ($d,$t,$st,$l_t,$l_user,$l_used,$c_ok,$c_failed,$c_avail, $c_ok_old,$c_failed_old);
my ($st,$i, $idx, $nn, $is_co);
#
#
my $monthly = 0;
my ($d_yy,$d_mon,$d_day) = split(/\./,$date);
if ( $d_day == 0 ) {
       $d_day = 1;
       $monthly = 1;
};
#    
my $I_0 = 0;
my $I_detail = ( $mode? 4 : 1); # 4 graph    graph, 1 /  
my $I_1 = 24 * $I_detail;
my @I_label = ();
$I_label[0]            =  "${F}0";
$I_label[6*$I_detail]  =  "${F}6";
$I_label[12*$I_detail] =  "${F}12";
$I_label[18*$I_detail] =  "${F}18";
my $I_name = "Hour";
my $file = "$dir/$date";
my $Nmarks = $I_detail;
if ( $monthly  ) {
    $I_detail = ($mode? 0.5: 1); # 1 graph  2  - graph, 1 / - report
    $I_0 = 0;
    $I_1 = int (31 * 24 * $I_detail) ;
    @I_label = ();
    for( $i = 5; $i < 31; $i += 5 ) {
	    $I_label[($i-1) * 12] = "${F}$i";
    };
    $I_name = "Day";
    $file = "cd $dir && cat $date* |";
    $Nmarks = int(24*$I_detail);
};
#
#   file
#
open(STAT,$file) || pt_fatal("No accounting file $file");
#
#  ,  ,   yes.
my ($yy, $mm, $dd, $hh, $min, $ss);
my ($cur_time, $last_time, $last_ok, $last_failed);
while ( <STAT> ) {
    chop;
    ($d,$t,$st,$l_t,$l_used,$l_user,$c_avail,$c_failed, $c_ok) = split(/[ \/,]+/);
    $d =~ /^(\d+)\.(\d+)\.(\d+)$/;
    $yy = $1; $mm = $2; $dd = $3;
    $t =~ /^(\d+)\:(\d+)\:(\d+)$/;
    $hh = $1; $min = $2; $ss = $3;
    $idx = int($hh * $I_detail + $min / (60 / $I_detail) );
    $idx += int(24 * ($dd - 1 ) * $I_detail) if $monthly;
    next if $idx < 0;
    #
    $Max_i = $idx if $Max_i < $idx;
    if ( $st ne "D" ) {
	$L_MAX = $l_t if $L_MAX < $l_t;
	$L_failed[$idx] = 1 if $st eq "P" && ! $L_failed[$idx]; # 1 -  
	$L_total[$idx] = $l_t if $L_total[$idx] < $l_t;
	$L_user[$idx] += $l_user;
	$L_max[$idx] = $l_used if ($l_used > $L_max[$idx]);
	$L_idle[$idx] += ($l_used - $l_user);
	if ( $c_ok ) {
	       $cur_time = $hh*3600 + $min*60 + $ss + $dd*(3600*24);
	       if ( $last_time && $cur_time > $last_time && $c_ok >= $last_ok && $c_failed >= $last_failed && $c_ok < $last_ok + 1000) {
		       $CO_ok[$idx] += ($c_ok - $last_ok) / ($cur_time - $last_time);
		       $CO_failed[$idx] += ($c_failed - $last_failed) / ($cur_time - $last_time);
	       };
	       $last_time = $cur_time;
	       $last_ok = $c_ok;
	       $last_failed = $c_failed;
	       $CO_NN[$idx]++;
	};
	#
	$L_NN[$idx]++;
    } else {
	$L_failed[$idx] = 2; # 2 -  
    };
};
#
#   file.   - (1) , (2)  for 
# (3)     ,      status.
#   ,    :
# L_idle -   IDLE,  
# L_user - ,  
# L_max  -  .
if ( $monthly == 1 && $Max_i > 20 ) {
       $I_1 = $Max_i if $Max_i < $I_1;
};
# If -  graph
if ( $mode ) {
    for ( $i = $I_0; $i <= $I_1; $i++) {
	$nn = $L_NN[$i];
	if ( $nn > 0 ) {
	    $L_user[$i] /= $nn;
	    $L_idle[$i] /= $nn;
	    #     .
	    $L_total[$i] -= ($L_user[$i]);
	    $L_total[$i] = 0 if $L_total[$i] < 0;
	    $L_max[$i] -= ($L_idle[$i] + $L_user[$i]);
	    $L_max[$i] = 0 if $L_max[$i] < 0;
	};
	if ( $L_failed[$i] ) {
		$L_on[$i] = 0;
		$L_off[$i] =0.1;
	} else {
		$L_on[$i] = 0.1;
		$L_off[$i] = 0;
	};
	if ( ($nn = $CO_NN[$i]) > 0 ) {
		$is_co = 1 if $CO_ok[$i]; #   for 
		#   1 
		$CO_ok[$i]     = ($CO_ok[$i]     * 3600 / $nn);
		$CO_failed[$i] = ($CO_failed[$i] * 3600 / $nn);
		$CO_MAX = ( $CO_ok[$i] + $CO_failed[$i] ) if ( $CO_ok[$i] + $CO_failed[$i] ) > $CO_MAX;
	};
    };
    #
    #
    #     graphs,   .
    #

    print <<EOFG1;
<TABLE>
<TR><TD COLSPAN=4 ALING=CENTER BGCOLOR=WHITE>$title </TD></TR>
<TR><TD VALIGN=TOP>
EOFG1
    #
    #
    #  graph  modem
    #           scale     idle  user  max       max
    my @gifs = ($G_Black, $G_O, $G_G, $G_Y,$G_R);
    my @Titles = ("${F}#Idle","${F}#User","${F}#Max","${F}Failures");
    my @pData = (\@L_idle, \@L_user,\@L_max, \@L_off);
    plot_graph(\@gifs, $I_0, $I_1,"${F}The business of the pool",\@Titles,"${F}$I_name\n",\@I_label ,\@pData,$L_MAX,$S_Gy,$S_Gx,0,$Nmarks,0);
    if ( $is_co && $mode != 3 ) {
	@Titles= ("Call statistic");
	@gifs = ($G_Black, $G_G, $G_O);
	@Titles = ("${F}Succeed","${F}Failed");
	@pData = (\@CO_ok,\@CO_failed);
	$CO_MAX = int($CO_MAX);
	print <<EOFG1;
</TD><TD VALIGN=TOP>
EOFG1
	plot_graph(\@gifs, $I_0, $I_1,"${F}Calls/h",\@Titles,"${F}$I_name\n",\@I_label ,\@pData,$CO_MAX,$S_Gy,$S_Gx,0,$Nmarks,0);
    };
    print <<EOFSx;
</TD>
</TR>
</TABLE>
EOFSx
    return(0);
    } else {
    my ($L_MAX,$L_MAX_09) = 0;
    for ( $i = $I_0; $i <= $I_1; $i++) {
	$nn = $L_NN[$i];
	$L_MAX = $L_max[$i] if $L_max[$i] > $L_MAX;
	if ( $nn > 0 ) {
	    $L_user[$i] /= $nn;
	    $L_idle[$i] /= $nn;
	};
	if ( $L_failed[$i] ) {
		$L_on[$i] = 0;
		$L_off[$i] =0.1;
	} else {
		$L_on[$i] = 0.1;
		$L_off[$i] = 0;
	};
	if ( ($nn = $CO_NN[$i]) > 0 ) {
		$is_co = 1 if $CO_ok[$i] > 0; #   for 
		#   1 
		$CO_ok[$i]     = ($CO_ok[$i]     * 3600 / $nn);
		$CO_failed[$i] = ($CO_failed[$i] * 3600 / $nn);
		$CO_MAX = ( $CO_ok[$i] + $CO_failed[$i] ) if ( $CO_ok[$i] + $CO_failed[$i] ) > $CO_MAX;
	};
    };
    $L_MAX_09 = $L_MAX * 9 / 10;
    print <<Eof1;
<CENTRE>The report for the modem pool <B>$title</B> for $date. The hours with the max loading are highlited</CENTRE>
<TABLE BORDER=2>
<TH>$I_name</TH>
Eof1
for ( $i = $I_0; $i <= $I_1; $i++) {
if ( $L_max[$i] >= $L_MAX_09 ) {
print <<Eof2;
<TH BGCOLOR="yellow">$i</TH>
Eof2
} else {
print <<Eof2;
<TH>$i</TH>
Eof2
};
};
print <<Eof3;
</TR>
<TD>Free</TD>
Eof3
for ( $i = $I_0; $i <= $I_1; $i++) {
$nn = int($L_total[$i] - ( $L_user[$i] + $L_idle[$i]));
if ( ! $L_total[$i] ) {
       print "<TD></TD>\n";
       next;
};
print <<Eof2;
<TD>$nn</TD>
Eof2
};
print <<Eof3;
</TR>
<TD>Busy</TD>
Eof3
for ( $i = $I_0; $i <= $I_1; $i++) {
$nn = int($L_user[$i] + $L_idle[$i]);
if ( ! $L_total[$i] ) {
       print "<TD></TD>\n";
       next;
};
print <<Eof2;
<TD>$nn</TD>
Eof2
};
print <<Eof3;
</TR>
<TD>Busy, max</TD>
Eof3
for ( $i = $I_0; $i <= $I_1; $i++) {
$nn = int($L_max[$i]);
if ( ! $L_total[$i] ) {
       print "<TD></TD>\n";
       next;
};
if ( $nn < $L_total[$i] - 3 ) {
print <<Eof4;
<TD>$nn</TD>
Eof4
} else {
print <<Eof4;
<TD><CONT COLOR="RED">$nn</FONT></TD>
Eof4

};
};
if ( $is_co ) {
print <<Eof5;
</TR>
<TD>Connections/hour</TD>
Eof5
for ( $i = $I_0; $i <= $I_1; $i++) {
if ( ! $L_total[$i] ) {
       print "<TD></TD>\n";
       next;
};
$nn = int($CO_ok[$i]);
print <<Eof6;
<TD>$nn</TD>
Eof6
};
print <<Eof7;
</TR>
<TD>Failures/hour</TD>
Eof7
for ( $i = $I_0; $i <= $I_1; $i++) {
if ( ! $L_total[$i] ) {
       print "<TD></TD>\n";
       next;
};
$nn = int($CO_failed[$i]);
print <<Eof8;
<TD>$nn</TD>
Eof8
};
print <<Eof9;
</TR>
<TD>Successfull</TD>
Eof9
for ( $i = $I_0; $i <= $I_1; $i++) {
if ( ! $L_total[$i] ) {
       print "<TD></TD>\n";
       next;
};
$nn = $CO_ok[$i] + $CO_failed[$i];
$nn = 2 if $nn < 1;
$nn = int($CO_ok[$i] * 100 / $nn);
print <<Eof10;
<TD>$nn%</TD>
Eof10
};
};
print <<Eof11;
</TR></TABLE>
Eof11
};
return(0);
};
