
#define NSUBEXP	10

typedef struct {
	char   *startp[NSUBEXP];	/* starting points of substrings */
	char   *endp[NSUBEXP];		/* exnding points of substrings */
	const char *matchstr;		/* the last matched string */
	int	matchstrlen;		/* length of the last matched string */
	int	magic;			/* a magic number */
	short 	hint;			/* hint for faster matching */
	char   *openpar[NSUBEXP];	/* opening par's in pgm + 1 */
	char   *closepar[NSUBEXP];	/* closing par's in pgm */
	char	pgm[1];			/* the program */
} regexp;

#ifndef __P
#define __P(x)	()
#endif

#define REGEXP_MAGIC	0xBADD00DE

extern void regerror __P((const char *msg));

extern regexp *regcomp __P((const char *exp));
extern void regprint __P((const regexp *r));
extern int regexec __P((regexp *r, const char *str));
extern void regsub __P((const regexp *r, const char *src, char *dst));
extern void regreplace __P((const regexp *r, const char *subst, char *dst));
extern int regnexec __P((regexp *r, const char *str, int len, unsigned strt));
extern int regnsub __P((const regexp *r, const char *src,
						int srclen, char *dst));
extern int regnreplace __P((const regexp *r, const char *subst,
						int slen, char *dst));
