/*
 * Copyright (C) 1993, US Sprint
 *
 * All Rights Reserved
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of US Sprint not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.
 *
 * US SPRINT DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * US SPRINT BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 *
 * Author: Vadim Antonov
 * Modifications - by Alex Roudnev
 *
 * $Log: config.h,v $
 * Revision 1.2  1999/07/20 19:06:27  alex
 * Extra files deleted
 *
 * Revision 1.1.1.1  1999/07/19 18:38:31  alex
 * First revision in cvs
 *
 * Revision 1.5  1998/03/20  19:02:40  alex
 * RELCOM
 *
 * Revision 1.4  1997/08/25  09:24:26  tim
 * *** empty log message ***
 *
 * Revision 1.3  1995/08/04  14:25:02  tim
 * Added some output (avg line load etc.)
 *
 * Revision 1.3  1995/08/04  14:25:02  tim
 * Added some output (avg line load etc.)
 *
 * Revision 1.2  1993/08/11  19:40:10  avg
 * Added copyright.
 *
 * Revision 1.1  1993/08/10  17:47:57  avg
 * Initial revision
 *
 * Revision 1.1  1993/08/10  17:47:57  avg
 * Initial revision
 *
 */

/*
 * The general configuration parameters
 */

/* The name of the configuration file */
#define CONFIG_FILE     "/usr/local/etc/Poll.conf"
/* #define CONFIG_FILE     "/srvs/rdbm/etc/Poll.conf"  */

/* The name of skeleton PostScript file */
#define PS_PROLOG_FILE  "/usr/local/etc/SnmpPlot.ps"
/* #define PS_PROLOG_FILE  "/srvs/rdbm/etc/SnmpPlot.ps" */

/* Lock file expiration time */
#define LOCK_EXPIRATION 60

/* The default polling period (seconds) */
#define DFLT_POLL       60

/* The default aggregation period (seconds) */
#define DFLT_AGGR       (15*60)

/* The default file change period */
#define DFLT_FCH        MONTHLY

/* Max number of interfaces per gateway */
#define MAXIFS          256

/* Polling interval for a dead gateway */
#define DEAD_POLL       20

/* SNMP retries */
#define SNMP_RETRIES    5

/* Max time to dump ifsum */

#define TIMEDUMP	120

/*
 * SNMP variable names (as in MIB)
 */
#define V_sysUptime       1,3,6,1,2,1,1,3,0
#define V_sysObjID        1,3,6,1,2,1,1,2,0
#define V_ifNumber        1,3,6,1,2,1,2,1,0
#define V_ifDescr         1,3,6,1,2,1,2,2,1,2,0
#define V_ifType	  1,3,6,1,2,1,2,2,1,3,0
#define V_ifSpeed         1,3,6,1,2,1,2,2,1,5,0
#define V_ifOperStatus    1,3,6,1,2,1,2,2,1,8,0
#define V_ifLastChange    1,3,6,1,2,1,2,2,1,9,0
#define V_ifInOctets      1,3,6,1,2,1,2,2,1,10,0
#define V_ifInUcastPkts   1,3,6,1,2,1,2,2,1,11,0
#define V_ifInNUcastPkts  1,3,6,1,2,1,2,2,1,12,0
#define V_ifInDrops       1,3,6,1,2,1,2,2,1,13,0
#define V_ifInErrors      1,3,6,1,2,1,2,2,1,14,0
#define V_ifOutOctets     1,3,6,1,2,1,2,2,1,16,0
#define V_ifOutUcastPkts  1,3,6,1,2,1,2,2,1,17,0
#define V_ifOutNUcastPkts 1,3,6,1,2,1,2,2,1,18,0
#define V_ifOutDrops      1,3,6,1,2,1,2,2,1,19,0
#define V_ifOutErrors     1,3,6,1,2,1,2,2,1,20,0

/*
 * cisco private variables
 */
#define V_ciscoProductID  1,3,6,1,4,1,9,1,0
#define V_ciscoFreeMem    1,3,6,1,4,1,9,2,1,8,0
#define V_ciscoAvgBusy    1,3,6,1,4,1,9,2,1,57,0
#define V_ciscoEnvPresent 1,3,6,1,4,1,9,2,1,77,0
#define V_ciscoEnvTemp    1,3,6,1,4,1,9,2,1,79,0

/*
 * BGP variables
 */
#define V_bgpVersion                  1,3,6,1,2,1,15,1,0
#define V_bgpLocalAS                  1,3,6,1,2,1,15,2,0
#define V_bgpPeerIdentifier           1,3,6,1,2,1,15,3,1,1
#define V_bgpPeerState                1,3,6,1,2,1,15,3,1,2,0,0,0,0       
#define V_bgpPeerAdminStatus          1,3,6,1,2,1,15,3,1,3
#define V_bgpPeerNegotiatedVersion    1,3,6,1,2,1,15,3,1,4
#define V_bgpPeerLocalAddr            1,3,6,1,2,1,15,3,1,5
#define V_bgpPeerLocalPort            1,3,6,1,2,1,15,3,1,6
#define V_bgpPeerRemoteAddr           1,3,6,1,2,1,15,3,1,7
#define V_bgpPeerRemotePort           1,3,6,1,2,1,15,3,1,8
#define V_bgpPeerRemoteAs             1,3,6,1,2,1,15,3,1,9,0,0,0,0 
#define V_bgpPeerInUpdates            1,3,6,1,2,1,15,3,1,10
#define V_bgpPeerOutUpdates           1,3,6,1,2,1,15,3,1,11
#define V_bgpPeerInTotalMessages      1,3,6,1,2,1,15,3,1,12
#define V_PeerOutTotalMessages        1,3,6,1,2,1,15,3,1,13
#define V_bgpPeerLastError            1,3,6,1,2,1,15,3,1,14
#define V_bgpPeerFsmEstablishedTime   1,3,6,1,2,1,15,3,1,16,0,0,0,0

/* CISCO-MEMORY-POOL-MIB.my */

#define V_ciscoMemoryPoolName		1,3,6,1,4,1,9,9,48,1,1,1,2,0
#define V_ciscoMemoryPoolAlternate	1,3,6,1,4,1,9,9,48,1,1,1,3,0
#define V_ciscoMemoryPoolValid		1,3,6,1,4,1,9,9,48,1,1,1,4,0
#define V_ciscoMemoryPoolUsed		1,3,6,1,4,1,9,9,48,1,1,1,5,0
#define V_ciscoMemoryPoolFree		1,3,6,1,4,1,9,9,48,1,1,1,6,0
#define V_ciscoMemoryPoolLargestFree	1,3,6,1,4,1,9,9,48,1,1,1,7,0
       
/* Bgp status states */
#define BGP_NEVER           0 /* Pseudo-status, for ifsum */
#define BGP_IDLE            1
#define BGP_CONNECT         2
#define BGP_ACTIVE          3
#define BGP_OPENSENT        4
#define BGP_OPENCONF        5
#define BGP_ESTABLISHED     6
#define BGP_INAC	    7 /* inaccessibale stat due to router don't aswer */

/* Line status constants */
#define IF_UP           1
#define IF_DOWN         2
#define IF_TESTING      3
#define IF_STAT         4       /* A pseudo-status for statisitcs records */
#define IF_INAC         5       /* inaccessibale stat due to router don't aswer */

/* Additional states - from ADMIN_STATUS && embedded keepalives. Use next numbers to make output
plain */
#define IF_SHUTDOWN    6
#define IF_INACTIVE    7

/* Gateway status states */
#define G_DOWN		0
#define G_UP		1
#define G_INAC		2
#define G_FIRST		3

/* dump name */
#define NameDump "/tmp/snmpstatd.dump"

/* ifType states */
#define ifType_default			0
#define ifType_other			1
#define ifType_regular1822		2
#define ifType_hdh1822			3
#define ifType_ddn_x25			4
#define ifType_rfc877_x25		5
#define ifType_ethernet_csmacd		6
#define ifType_iso88023_csmacd		7
#define ifType_iso88024_tokenBus	8
#define ifType_iso88025_tokenRing	9
#define ifType_iso88026_man		10
#define ifType_starLan			11
#define ifType_proteon_10Mbit		12
#define ifType_proteon_80Mbit		13
#define ifType_hyperchannel		14
#define ifType_fddi			15
#define ifType_lapb			16
#define ifType_sdlc			17
#define ifType_ds1			18
#define ifType_e1			19
#define ifType_basicISDN		20
#define ifType_primaryISDN		21
#define ifType_propPointToPointSerial	22
#define ifType_ppp			23
#define ifType_softwareLoopback		24
#define ifType_eon			25
#define ifType_etherne_3Mbit		26
#define ifType_nsip			27
#define ifType_slip			28
#define ifType_ultra			29
#define ifType_ds3			30
#define ifType_sip			31
#define ifType_frame_relay		32
#define ifType_aal5			49
