/*
 * Copyright (C) 1993, US Sprint
 *
 * All Rights Reserved
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of US Sprint not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.
 *
 * US SPRINT DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * US SPRINT BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 *
 * Author: Vadim Antonov
 *
 * $Log: display.c,v $
 * Revision 1.1.1.1  1999/07/19 18:38:31  alex
 * First revision in cvs
 *
 * Revision 1.5  1998/03/20  19:02:40  alex
 * RELCOM
 *
 * Revision 1.4  1995/12/11  14:56:22  tim
 * *** empty log message ***
 *
 * Revision 1.4  1995/12/11  14:56:22  tim
 * *** empty log message ***
 *
 * Revision 1.3  1995/08/04  14:25:02  tim
 * Added some output (avg line load etc.)
 *
 * Revision 1.3  1995/08/04  14:25:02  tim
 * Added some output (avg line load etc.)
 *
 * Revision 1.2  1993/08/11  19:40:10  avg
 * Added copyright.
 *
 * Revision 1.2  1993/08/11  19:40:10  avg
 * Added copyright.
 *
 * Revision 1.1  1993/08/10  17:47:57  avg
 * Initial revision
 *
 * Revision 1.1  1993/08/10  17:47:57  avg
 * Initial revision
 *
 */
#ifndef lint
static char rcsid[] = "$Id: display.c,v 1.1.1.1 1999/07/19 18:38:31 alex Exp $";
#endif

/*
 * Display the contents of a file
 * and then see if it changes.
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>

toutc(c)
	int c;
{
	putchar(c);
}

main(ac, av)
	int ac;
	char **av;
{
	char tbuf[1024], buf[128];
	int f, l;
	extern char *getenv(), *tgetstr();
	char *term, *t_cd, *t_cl, *t_ho;
	char *bp;
	struct stat st0, st1;

	if( ac != 2 ) {
		fprintf(stderr, "Usage: %s file\n", av[0]);
		exit(1);
	}
	if( (f = open(av[1], 0)) < 0 ) {
		fprintf(stderr, "%s: cannot open file %s\n", av[0], av[1]);
		exit(1);
	}

	/* Try to get screen erasing sequence from termcap */
	t_cl = t_cd = t_ho = 0;
	if( (term = getenv("TERM")) &&
	    tgetent(tbuf, term) == 1 ) {
		bp = buf;
		t_cl = tgetstr("cl", &bp);
		t_cd = tgetstr("cd", &bp);
		t_ho = tgetstr("ho", &bp);
	}

	/* The loop */
	for(;;) {
		/* Erase screen */
		if( t_cl )
			tputs(t_cl, 1, toutc);
		else if( t_ho && t_cd ) {
			tputs(t_ho, 1, toutc);
			tputs(t_cd, 1, toutc);
		} else
			printf("\n-----------------------------------\n");

		/* Print the file */
		lseek(f, 0l, 0);
		while( (l = read(f, tbuf, sizeof tbuf)) > 0 )
			fwrite(tbuf, l, 1, stdout);
		fflush(stdout);

		/* Wait for changes */
		fstat(f, &st0);
		do {
			sleep(1);
			fstat(f, &st1);
		} while( st0.st_mtime == st1.st_mtime &&
			 st0.st_size == st1.st_size );
	}
	/*NOTREACHED*/
}
