/*
 * Copyright (C) 1993, US Sprint
 *
 * All Rights Reserved
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of US Sprint not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.
 *
 * US SPRINT DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * US SPRINT BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 *
 * Author: Vadim Antonov
 *
 * $Log: dump.c,v $
 * Revision 1.1.1.1  1999/07/19 18:38:31  alex
 * First revision in cvs
 *
 * Revision 1.6  1998/03/20  19:02:40  alex
 * RELCOM
 *
 * Revision 1.5  1997/08/26  16:06:03  tim
 * emty tim
 *
 * Revision 1.4  1995/12/11  14:56:22  tim
 * *** empty log message ***
 *
 * Revision 1.4  1995/12/11  14:56:22  tim
 * *** empty log message ***
 *
 * Revision 1.3  1995/08/04  14:25:02  tim
 * Added some output (avg line load etc.)
 *
 * Revision 1.3  1995/08/04  14:25:02  tim
 * Added some output (avg line load etc.)
 *
 * Revision 1.2  1993/08/11  19:40:10  avg
 * Added copyright.
 *
 * Revision 1.2  1993/08/11  19:40:10  avg
 * Added copyright.
 *
 * Revision 1.1  1993/08/10  17:47:57  avg
 * Initial revision
 *
 * Revision 1.1  1993/08/10  17:47:57  avg
 * Initial revision
 *
 */
#ifndef lint
static char rcsid[] = "$Id: dump.c,v 1.1.1.1 1999/07/19 18:38:31 alex Exp $";
#endif

#include "manifest.h"

void poll_send();
void poll_ptimo();
void outgwstat();
void aggregate();
void net_state();
void touch_lock();

/*
 * Print out the internal data structures
 */
void dump()
{
	extern struct SNMP_ACTION *aqh;
	struct GATEWAY *g;
	struct IF *ii;
	struct SNMP_ACTION *a;
	int i;
	static char *los[] = { 0, "UP", "DOWN", "TESTING" };
	static char *fch[] = {
		"NONE", "DAILY", "WEEKLY", "MONTHLY", "YEARLY"
	};
	FILE *fd;

        if ((fd=fopen(NameDump,"w")) == NULL) return;

	fprintf(fd,"Polling period=%d, Aggregating period=%d\n",
		poll_period, aggr_period);
	fprintf(fd,"Base directory='%s', File change=%s\n", base_dir,
		fch[file_change]);
	fprintf(fd,"Notify file='%s' Error threshold=%.2f\n", notify_file,
		err_threshold);

	for( g = gwlist ; g ; g = g->g_next ) {
		fprintf(fd,"%s '%s' %d {\n", g->g_name, g->g_cname, g->g_n);
		fprintf(fd," >>> alive=%d uptime=%d ngwifs=%d nwait=%d\n",
			g->g_alive, g->g_uptime, g->g_ngwifs, g->g_nwait);

		if( g->g_poll )
			fprintf(fd,"\tPOLL\t%d\n", g->g_poll);
		ii = g->g_ifs;
		for( i = 0 ; i < g->g_nifs ; i++, ii++ ) {
			fprintf(fd,"\t%s\t%s\t%s\n", ii->i_name,
						 ii->i_logdir,
						 ii->i_comment);
			fprintf(fd,"\t >>> index=%d, ", ii->i_index);
			fprintf(fd,"Type=%d, Speed=%d, OperStatus=%s\n",
				ii->i_type, ii->i_cs.l_Speed, los[ii->i_cs.l_OperStatus]);
		}
		fprintf(fd,"}\n");
		if( g->g_next )
			fprintf(fd,"\n");

	}

	fprintf(fd,"EVENTS:\n");
	for( a = aqh ; a ; a = a->a_next ) {
		fprintf(fd,"\t%d\t", a->a_time - time(0));
		if( a->a_f == poll_send || a->a_f == poll_ptimo ) {
			g = (struct GATEWAY *) a;
			fprintf(fd,"%s: %s state=%d",
				a->a_f == poll_send ? "POLL" : "PTIMO",
				g->g_name, g->g_ps);
		} else if( a->a_f == outgwstat ) {
			g = (struct GATEWAY *) (a - 1);
			fprintf(fd,"OUTGW: %s", g->g_name);
		} else if( a->a_f == aggregate )
			fprintf(fd,"AGGR");
		else if( a->a_f == net_state )
			fprintf(fd,"NETSTATE");
		else if( a->a_f == touch_lock )
			fprintf(fd,"LOCK");
		else
			fprintf(fd,"???");
		fprintf(fd,"\n");
	}
	fclose(fd);
}
