#!/usr/bin/perl
#
#    SNMP ,  
# ,      ,  , 
#    .
# 
# -D        (/var/stat - )
# -T _    (  - 30).
#     ,     ,  
#      snmpstatd.
#
# 1.  
$DIR="/var/stat/STAT";
#
$TIME_D=28;
# 2.  
#
while ( $_ = shift(@ARGV) ) {
       $DIR = shift(@ARGV) if $_ eq "-D";
       $TIME_D = shift(@ARGV) if $_ eq "-T";
};
#
# 3.    .
#
chdir $DIR || die("Can't chdir to $DIR");
#
# 3.1   .
#
$cur_time=time();
@t_tm = localtime($cur_time);
#
#  ,   
#
$t_y = $t_tm[5] + 1900;
$t_m = $t_tm[4] + 1;
$t_d = $t_tm[3];
#
# 4.      
#
opendir(STAT,".") || die("Can't open . in $DIR");
@DLIST=readdir STAT;
closedir STAT;
#
# 5.    ,     
#
foreach $D (@DLIST) {
       # 5.1. ,   .
       next if ! -d $D;
       # 5.2  .    ,  
       #  .      (  )
       #      
       if ( ! opendir(DIR,$D) ) {
	      print STDERR "Can't open dir $D, skipped\n";
	      next;
       };
       @FLIST = readdir DIR;
       closedir DIR;
       foreach $F (@FLIST) {
	      #
	      #  ,      YYYY.MM.DD  YY.MM.DD
	      #
	      next if $F !~ /^(\d\d\d\d)\.(\d\d)\.(\d\d)$/ && $F !~ /^(\d\d)\.(\d\d)\.(\d\d)$/;
	      $n_files++;
	      #
	      #        ,   
	      #   ,      30 ,   + / - 1 
	      #      .
	      #
	      $f_y = $1;
	      $f_m = $2;
	      $f_d = $3;
	      $f_y += 1900 if $f_y < 1900;
	      #
	      $t_dd = $t_y*366 + $t_m*30 + $t_d;
	      $f_dd = $f_y*366 + $f_m*30 + $f_d;
	      #
	      #     ,   
	      #
	      next if $t_dd - $f_dd < $TIME_D;
	      #
	      # .   .
	      #
	      do_summ($D,$F,$f_y,$f_m, $f_d);
	      $n_summ++;
	      #
	      #    
	      #
       };
       #
       #    
       #
};
#
#  
#
print "Total directories: $n_dir, files $n_files, summarizeed and deleted $n_summ\n";
#
# 
#
exit 0;

#
#  ,     
#
sub do_summ {
    my ($dir, $file, $year, $month, $day) = @_;
    #
    #   
    #
    open(FILE,"$dir/$file") || return(0);
    #    
#    open MONTH,">&STDOUT";
    print "$dir/$file >> $dir/$year.$month started\n";
    if ( ! open(MONTH,">> $dir/$year.$month" )) {
	   print STDERR "Can't open $dir/$year.$month for the addition\n";
	   return(0);
    };
    #   
    @s_arr=();
    $na = 0;
    #  /
    $s_dt="";
    %s_state = ();
    #
    #   -  
    #
fileloop:
    while ( ( $_ = <FILE> ) || $s_dt ) {
##           print "\t$_";
	   chop;
	   ($dt,$tm,$rest) = split(/ +/,$_,3);
	   #
	   # 1.     
	   #
	   $tm1 = $tm;
	   $tm =~ s/^(\d+):\d+:\d+$/$1:00:00/;
	   if ( $s_dt && $s_dt ne "$dt $tm" ) {
flush_l:
	      {
		       foreach $i ("FIRST","INAC","DOWN","UP") {
			       print MONTH "$dt $tm $s_state{$i}\n" if $s_state{$i} ;
		       };
		       %s_state = ();
		       print MONTH "$s_dt ",@s_arr,"\n" if $na ;
		       #      .
		       $s_dt = "";
		       @s_arr = ();
		       $na = 0;
		       #     - ,  
		       last fileloop if ! $_ ;
	       };
	   };
	   $s_dt = "$dt $tm";
	   $_ = $rest;
	   if ( /^(UP)/ || /^(DOWN)/ || /^(FIRST)/ || /^(INAC)/ ) {
		   $s_state{$1} = $_;
		   next;
	   };
	   @s_arr1 = split(/([^0-9.]+)/,$rest );
	   $na++;   #   . ,       
	   for ( $i = 0; $i <= $#s_arr1; $i++ ) {
		   #
		   #      
		   #
		   $n = $s_arr1[$i];
		   $o = $s_arr[$i];
##                   print "$na $s_dt i: $i $n ~ $o\n";
		   #    ,   
		   if ( $i > $#s_arr ) {
			   $s_arr[$i] = $n;
			   next;
		   };
		   #      -  ,    
		   #  ,   . ,     $na 
		   # ,      ,   ,
		   #         .
		   if ( $n ne $o && ( $n !~ /\d/ || $o !~ /\d/ ) )  {
			   goto flush_l;
		   };
		   #
		   #   ,   . 
		   #    ,   
		   if ( $n =~ /\d\.\d/ ) {
			   $o = sprintf "%3.2f", (( $o * ($na-1) + $n ) / ( $na  ));
			   $s_arr[$i] = $o;
			   next;
		   };
		   if ( $n =~ /\d/ ) {
			   $o = int( ( $o * ( $na-1) + $n ) / ( $na ));
			   $s_arr[$i] = $o;
		   };
	    };
	};
    goto flush_l if $s_dt;
    close(MONTH);
    close(FILE);
    print "completed\n";
    unlink("$dir/$file") || print "Can't unlink $!\n";
    return(1);
};
